/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
	"time"
)

// checks if the BongoReceipt type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BongoReceipt{}

// BongoReceipt struct for BongoReceipt
type BongoReceipt struct {
	Status string `json:"status"`
	Error string `json:"error"`
	ReceiptData map[string]interface{} `json:"receipt_data"`
	Attempt int32 `json:"attempt"`
	Id string `json:"id"`
	TransactionId string `json:"transaction_id"`
	ContactId string `json:"contact_id"`
	ConversationId string `json:"conversation_id"`
	ChannelId string `json:"channel_id"`
	OrganizationId string `json:"organization_id"`
	ReceiptUrl string `json:"receipt_url"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewBongoReceipt instantiates a new BongoReceipt object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBongoReceipt(status string, error_ string, receiptData map[string]interface{}, attempt int32, id string, transactionId string, contactId string, conversationId string, channelId string, organizationId string, receiptUrl string, createdAt time.Time, updatedAt time.Time) *BongoReceipt {
	this := BongoReceipt{}
	this.Status = status
	this.Error = error_
	this.ReceiptData = receiptData
	this.Attempt = attempt
	this.Id = id
	this.TransactionId = transactionId
	this.ContactId = contactId
	this.ConversationId = conversationId
	this.ChannelId = channelId
	this.OrganizationId = organizationId
	this.ReceiptUrl = receiptUrl
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewBongoReceiptWithDefaults instantiates a new BongoReceipt object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBongoReceiptWithDefaults() *BongoReceipt {
	this := BongoReceipt{}
	return &this
}

// GetStatus returns the Status field value
func (o *BongoReceipt) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *BongoReceipt) SetStatus(v string) {
	o.Status = v
}

// GetError returns the Error field value
func (o *BongoReceipt) GetError() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Error
}

// GetErrorOk returns a tuple with the Error field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetErrorOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Error, true
}

// SetError sets field value
func (o *BongoReceipt) SetError(v string) {
	o.Error = v
}

// GetReceiptData returns the ReceiptData field value
func (o *BongoReceipt) GetReceiptData() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.ReceiptData
}

// GetReceiptDataOk returns a tuple with the ReceiptData field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetReceiptDataOk() (map[string]interface{}, bool) {
	if o == nil {
		return map[string]interface{}{}, false
	}
	return o.ReceiptData, true
}

// SetReceiptData sets field value
func (o *BongoReceipt) SetReceiptData(v map[string]interface{}) {
	o.ReceiptData = v
}

// GetAttempt returns the Attempt field value
func (o *BongoReceipt) GetAttempt() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Attempt
}

// GetAttemptOk returns a tuple with the Attempt field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetAttemptOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Attempt, true
}

// SetAttempt sets field value
func (o *BongoReceipt) SetAttempt(v int32) {
	o.Attempt = v
}

// GetId returns the Id field value
func (o *BongoReceipt) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *BongoReceipt) SetId(v string) {
	o.Id = v
}

// GetTransactionId returns the TransactionId field value
func (o *BongoReceipt) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *BongoReceipt) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetContactId returns the ContactId field value
func (o *BongoReceipt) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *BongoReceipt) SetContactId(v string) {
	o.ContactId = v
}

// GetConversationId returns the ConversationId field value
func (o *BongoReceipt) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *BongoReceipt) SetConversationId(v string) {
	o.ConversationId = v
}

// GetChannelId returns the ChannelId field value
func (o *BongoReceipt) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *BongoReceipt) SetChannelId(v string) {
	o.ChannelId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *BongoReceipt) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *BongoReceipt) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetReceiptUrl returns the ReceiptUrl field value
func (o *BongoReceipt) GetReceiptUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReceiptUrl
}

// GetReceiptUrlOk returns a tuple with the ReceiptUrl field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetReceiptUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReceiptUrl, true
}

// SetReceiptUrl sets field value
func (o *BongoReceipt) SetReceiptUrl(v string) {
	o.ReceiptUrl = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *BongoReceipt) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *BongoReceipt) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *BongoReceipt) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *BongoReceipt) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *BongoReceipt) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o BongoReceipt) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BongoReceipt) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["status"] = o.Status
	toSerialize["error"] = o.Error
	toSerialize["receipt_data"] = o.ReceiptData
	toSerialize["attempt"] = o.Attempt
	toSerialize["id"] = o.Id
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["receipt_url"] = o.ReceiptUrl
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableBongoReceipt struct {
	value *BongoReceipt
	isSet bool
}

func (v NullableBongoReceipt) Get() *BongoReceipt {
	return v.value
}

func (v *NullableBongoReceipt) Set(val *BongoReceipt) {
	v.value = val
	v.isSet = true
}

func (v NullableBongoReceipt) IsSet() bool {
	return v.isSet
}

func (v *NullableBongoReceipt) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBongoReceipt(val *BongoReceipt) *NullableBongoReceipt {
	return &NullableBongoReceipt{value: val, isSet: true}
}

func (v NullableBongoReceipt) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBongoReceipt) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


